// Adapters.cpp : CAdapters ̃Cve[V
#include "stdafx.h"
#include "MacCap.h"
#include "Adapters.h"

/////////////////////////////////////////////////////////////////////////////
// CAdapters

HRESULT STDMETHODCALLTYPE CAdapters::get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppenum)
{
	if (!ppenum) return E_POINTER;
	*ppenum = NULL;
	typedef CComObject<CComEnumOnSTL<IEnumVARIANT, &IID_IEnumVARIANT, VARIANT, _Copy<VARIANT>, std::list<VARIANT> > > enumvar;
	enumvar* p = NULL;
	ATLTRY(p = new enumvar);
	if(p == NULL)
		return E_OUTOFMEMORY;
	HRESULT hRes = p->Init(GetControllingUnknown(), m_listAdapters);
	if (SUCCEEDED(hRes))
		hRes = p->QueryInterface(IID_IEnumVARIANT, (void**)ppenum);
	if (FAILED(hRes))
		delete p;
	return hRes;
}

HRESULT STDMETHODCALLTYPE CAdapters::get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult)
{
	if (!pResult) return E_POINTER;
	*pResult = m_listAdapters.size();
	return S_OK;
}

HRESULT CAdapters::FinalConstruct()
{
    HKEY       SystemKey;
    HKEY       ControlSetKey;
    HKEY       ServicesKey;
    HKEY       NdisPerfKey;
    HKEY       LinkageKey;

    LONG Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SYSTEM"), 0, KEY_READ, &SystemKey);
    if (Status == ERROR_SUCCESS) 
	{
        Status=RegOpenKeyEx(SystemKey, _T("CurrentControlSet"), 0, KEY_READ, &ControlSetKey);
        if (Status == ERROR_SUCCESS) 
		{
            Status=RegOpenKeyEx(ControlSetKey, _T("Services"), 0, KEY_READ, &ServicesKey);
            if (Status == ERROR_SUCCESS) 
			{
                Status=RegOpenKeyEx(ServicesKey, _T("NCapDD"), 0, KEY_READ, &NdisPerfKey);
                if (Status == ERROR_SUCCESS) 
				{
                    Status=RegOpenKeyEx(NdisPerfKey, _T("Linkage"), 0, KEY_READ, &LinkageKey);
                    if (Status == ERROR_SUCCESS) 
					{
						DWORD cbData, RegType;
                        Status=RegQueryValueEx(LinkageKey, _T("Export"), NULL, &RegType, NULL, &cbData);
						if (Status == ERROR_SUCCESS)
						{
							USES_CONVERSION;
							LPTSTR pstr = (LPTSTR)_alloca(cbData + 16);
							Status = RegQueryValueEx(LinkageKey, _T("Export"), NULL, &RegType, (LPBYTE)pstr, &cbData);
							while (*pstr)
							{
								int len = lstrlen(pstr);
								VARIANT v;
								VariantInit(&v);
								v.vt = VT_BSTR;
								v.bstrVal = SysAllocString(T2OLE(pstr));
								m_listAdapters.push_back(v);
								pstr += len + 1;
							}
						}
                        RegCloseKey(LinkageKey);
                    }
                    RegCloseKey(NdisPerfKey);
                }
                RegCloseKey(ServicesKey);
            }
            RegCloseKey(ControlSetKey);
        }
        RegCloseKey(SystemKey);
    }

    return (Status == ERROR_SUCCESS) ? S_OK : S_FALSE;
}


